;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; UCAsm Example Code
;; (c) Copyright 2007 Burnt Wasp and Figment Games
;;     All Rights Reserved.
;;
;; Filename:    LEDTest.asm
;; Author:      Tom Bampton
;; Created:     1/4/2007
;; Purpose:
;;   Multi-Cog LED Blinker
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                include         "p8x32a.inc"

                ; For real hardware
                ;clkmode         XTAL1_PLL16X
                ;xinfreq         6_000_000

                ; For emulator
                clkmode         RCFAST
                clkfreq         1_000

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Startup Cog
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                cog             $20

StartupCog      ; Start new cogs
                cognew          Blinker, @blinkCog1
                cognew          Blinker, @blinkCog2
                cognew          Blinker, @blinkCog3
                cognew          Blinker, @blinkCog4

                ; Stop this cog
                stopCurCog

                ; Masks for the blinker cogs (passed via PAR)
blinkCog1       long            $FF00_0000
blinkCog2       long            $00FF_0000
blinkCog3       long            $0000_FF00
blinkCog4       long            $0000_00FF

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Blinker Cog
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                cog
Blinker         rdlong          mask, PAR

                mov             DIRA, mask

                mov             time, CNT
                add             time, clockFreq

:blink          or              OUTA, mask
                waitcnt         time, clockFreq
                andn            OUTA, mask
                waitcnt         time, clockFreq

                jmp             #:blink


mask            res             1
clockFreq       long            _CLKFREQ
time            res             1
