;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Urinal Cake Assembler
;; (c) Copyright 2007 Burnt Wasp and Figment Games
;;     All Rights Reserved.
;;
;; Filename:    crc32.inc
;; Author:      Tom Bampton
;; Created:     5/4/2007
;; Purpose:
;;   Assembly time CRC32 table generation
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                ifndef          UCA_CRC32_INC
UCA_CRC32_INC   equ             1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Generate a CRC32 lookup table at assembly time.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

buildCRC32Tab   macro

i               =               0
                while           i < 256
val                     =               i

j                       =               0
                        while           j < 8

                                if              val & $01
val                             =               0xedb88320 ^ (val >> 1)
                                else
val                             =               val >> 1
                                end

j                               =               j + 1
                        end


                ; Store data
                long            val

i               =               i + 1
                end

                end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                end             ; UCA_CRC32_INC
